![Tests](https://github.com/pmlmodelling/ersem/workflows/build-ersem/badge.svg) 
[![Documentation Status](https://readthedocs.org/projects/ersem/badge/?version=latest)](https://ersem.readthedocs.io/en/latest/?badge=latest)

# ERSEM

![ERSEM diagram](docs/images/ERSEM.png)

[ERSEM](http://ersem.com) is a marine biogeochemical and ecosystem model. It describes the
cycling of carbon, nitrogen, phosphorus, silicon, oxygen and iron through 
the lower trophic level pelagic and benthic ecosystems. 

- **Installation Instructions:** conda: https://ersem.readthedocs.io/en/latest/tutorials/index.html#conda-installation, source: https://ersem.readthedocs.io/en/latest/developers/index.html
- **User Documentation & Example Usage:** https://ersem.readthedocs.io/en/latest/
- **Automated Tests:** Run via GitHub Actions https://github.com/pmlmodelling/ersem/actions
- **Acknowledgements:** https://ersem.readthedocs.io/en/latest/acknowledgements.html
- **License:** https://ersem.readthedocs.io/en/latest/license.html

# Support

We strongly encourage everyone using the ERSEM code to register as a user by filling a
[short registration form](https://forms.office.com/r/X0iXv8AvTC). 
We’d love to get a better understanding of who is using the ERSEM code and for what 
applications, as it will help us to provide the best support to the user community. 
It will also allow you to receive information and news on the latest model developments.

# How to cite

To refer to ERSEM in publications, please cite:

Butenschön, M., Clark, J., Aldridge, J.N., Allen, J.I., Artioli, Y.,
Blackford, J., Bruggeman, J., Cazenave, P., Ciavatta, S., Kay, S., Lessin, G.,
van Leeuwen, S., van der Molen, J., de Mora, L., Polimene, L., Sailley, S.,
Stephens, N., Torres, R. (2016). ERSEM 15.06: a generic model for marine
biogeochemistry and the ecosystem dynamics of the lower trophic levels.
Geoscientific Model Development, 9(4), 1293–1339.
doi: [10.5194/gmd-9-1293-2016](https://doi.org/10.5194/gmd-9-1293-2016).

To refer specifically to the ERSEM source code, you may use its Zenodo DOI:

[![DOI](https://zenodo.org/badge/302390544.svg)](https://zenodo.org/badge/latestdoi/302390544)

