/* This include file is automatically generated by Cython for 'public' functions. */
#include "fabm_base.h"

#ifdef __cplusplus
extern "C" {
#endif

   int embedded_python_initialize(const char* program_name, const char* home)
   {
      PyStatus status;

      PyConfig config;
      PyConfig_InitPythonConfig(&config);

      status = PyConfig_SetBytesString(&config, &config.program_name, program_name);
      if (PyStatus_Exception(status)) goto error;

      status = PyConfig_SetBytesString(&config, &config.home, home);
      if (PyStatus_Exception(status)) goto error;

      status = PyConfig_SetString(&config, &config.pythonpath_env, L"");
      if (PyStatus_Exception(status)) goto error;

      /* Add a built-in module, before Py_Initialize */
      if (PyImport_AppendInittab("fabm_base", PyInit_fabm_base) == -1) {
         fprintf(stderr, "Error: could not extend in-built modules table\n");
         goto error;
      }

      /* Initialize the Python interpreter.  Required.
         If this step fails, it will be a fatal error. */
      status = Py_InitializeFromConfig(&config);
      if (PyStatus_Exception(status)) goto error;

      PyConfig_Clear(&config);
      return(0);
   error:
      if (PyStatus_Exception(status)) fprintf(stderr, status.err_msg);
      PyConfig_Clear(&config);
      return(1);
   }


   PyObject* embedded_python_get_model(const char* module_name, const char* class_name, void* base) {
      PyObject* pmodule;
      PyObject* pclass;
      PyObject* presult;

      pmodule = PyImport_ImportModule(module_name);
      if (pmodule == NULL)  goto error;
      pclass = PyObject_GetAttrString(pmodule, class_name);
      if (pclass == NULL) goto error;
      pnext_base = base;
      presult = PyObject_CallNoArgs(pclass);
      if (presult == NULL) goto error;
      return(presult);

   error:
      PyErr_Print();
      return(NULL);
   }

#ifdef __cplusplus
}
#endif