## SELMA - Simple EcoLogical Model for the Aquatic 

The PROGNOS project (PREDICTING IN-LAKE RESPONSES TO CHANGE USING 
NEAR REAL TIME MODELS) is working to develop short-term water quality
forecasts by coupling high frequency lake monitoring data and future
weather forecast data to lake hydrodynamic and biogeochemical models
using FABM.
This integrated approach that couples HF data to dynamic models to 
forecast short-term changes in lake state, will inform management 
decisions to help safeguard the ecosystem services that lakes provide.
PROGNOS is funded by the EU and national funding agencies of Sweden,
Denmark, Norway, Ireland and Israel under the ERA-NET WaterWorks2014
Water JPI Cofunded Call (http://www.waterjpi.eu)

Coded by Gennadi Lessin (PML) based upon code provided by Thomas Neumann
(IOW) and updates the older version of ERGOM included in GOTM-BIO.
This older version is still provided in FABM under the name gotm/ergom for           
historical/educational purposes.                                           

A detailed description of the original model is given                     
in T. Neumann, W. Fennel and C. Kremp, 2002. Experimental simulations     
with an ecosystem model of the Baltic Sea: a nutrient load reduction      
experiment. Global Biogeochemical Cycles, 16 (3).                         
http://dx.doi.org/10.1029/2001GB001450.                                   

The present version adds oxygen-dependent phosphorus dynamics     
between sediment and water and the effect of bio-resuspension, as         
described in T. Neumann and G. Schernewski, 2008. Eutrophication in the   
Baltic Sea and shifts in nitrogen fixation analyzed with a 3D ecosystem   
model, J. Mar. Sys., 74 (1.2), pp. 592-602. 

