## DOMCAST - a module for dissolved organic carbon modelling in humic lakes

The PROGNOS project (PREDICTING IN-LAKE RESPONSES TO CHANGE USING NEAR REAL TIME MODELS) is working to develop short-term water quality 
forecasts by coupling high frequency lake monitoring data and future weather forecast data to lake hydrodynamic and biogeochemical models 
using the Framework for Aquatic Biogeochemical Modelling (FABM).  This integrated approach that couples HF data to dynamic models to 
forecast short-term changes in lake state, will inform management decisions to help safeguard the ecosystem services that lakes provide.  
PROGNOS is funded by the EU and national funding agencies of Sweden, Denmark, Norway, Ireland and Israel under the ERA-NET WaterWorks2014 
Water JPI Cofunded Call (http://www.waterjpi.eu)

Coded by Raoul-Marie Couture (Université Laval) and Jose-Luis Guerrero (NIVA), and updated by Francois Clayer (NIVA).
DOMCAST is a model of DOM processing in freshwater part of the PROGNOS project. Three key processes responsible for DOC processing 
are represented in the model: microbial metabolism, photomineralization, and flocculation-driven sedimentation.
DOMCAST requires SELMA: https://github.com/fabm-model/fabm/tree/master/src/models/selma

A manuscript for a detailed description of the model is currently under preparation. DOMCAST is based on the version of MyLake 
described in H. de Wit et al. (2018): Pipes or chimneys? For carbon cycling in small boreal lakes,
precipitation matters most. https://doi.org/10.6084/m9.figshare.5944015.v2.
